function A = choose_contest()

A = [];

mystr = ' erdrey | geo | gilbert | kleinberg | lockandkey | pref | renga | smallw | sticky';

pos = [.1 .2 .63 .6];
ff = figure('MenuBar', 'none', 'Name', 'Choose model', ...
	'NumberTitle', 'off',...
	'units','normalized',...
	'position', pos,'hittest', 'off', 'resize', 'on');


lista = uicontrol(ff,'Style','listbox', 'units', 'normalized', ...
	'Position', [.02 .53 .2 .43],...
	'Backgroundcolor', [1.0 1.0 1.0],...
	'String', mystr, 'fontweight', 'bold', 'fontsize',12);

init_str_help = sprintf('\nPress Help to get help for each model. \n\nYou can set only the number of nodes and leave other parameters to their default values.');

help_text = uicontrol(ff,'Style','text', 'units','normalized', ...
	'Position',[.24 .012 .74 .948], 'Backgroundcolor',[1.0 1.0 1.0], ...
	'horizontalalignment', 'left', ...
	'string', init_str_help, 'fontweight', 'bold', 'fontsize', 12);


B_help = uicontrol(ff,'Style','pushbutton',...
	'units','normalized', 'Position', [.03 .54 .15 .05], ...
	'String','Help',...
	'Callback',@help_plot);

B_ok = uicontrol(ff,'Style','pushbutton',...
	'units','normalized', 'Position', [.01 .01 .1 .07], ...
	'String','OK',...
	'Callback',@OK_plot);

B_annulla = uicontrol(ff,'Style','pushbutton',...
	'units','normalized', 'Position', [.13 .01 .1 .07], ...
	'String','Cancel',...
	'Callback',@annulla_plot);

node_text = uicontrol(ff,'Style','text', 'units','normalized', ...
	'Position',[.02 .46 .1 .04], ...
	'horizontalalignment', 'right', ...
	'string', 'n ', 'fontsize',12);
node_edit = uicontrol(ff,'Style','edit', 'units','normalized', ...
	'Position',[.12 .46 .1 .04], ...
	'horizontalalignment', 'left', 'fontsize',12, ...
	'Backgroundcolor',[1.0 1.0 1.0]);

text1 = uicontrol(ff,'Style','text', 'units','normalized', ...
	'Position',[.02 .37 .1 .04], ...
	'horizontalalignment', 'right', ...
	'fontsize',12, 'visible', 'off');
edit1 = uicontrol(ff,'Style','edit', 'units','normalized', ...
	'Position',[.12 .37 .1 .04], ...
	'horizontalalignment', 'left', 'fontsize',12, ...
	'Backgroundcolor',[1.0 1.0 1.0], 'string', 'def.', 'visible', 'off');

text2 = uicontrol(ff,'Style','text', 'units','normalized', ...
	'Position',[.02 .28 .1 .04], ...
	'horizontalalignment', 'right', ...
	'fontsize',12, 'visible', 'off');
edit2 = uicontrol(ff,'Style','edit', 'units','normalized', ...
	'Position',[.12 .28 .1 .04], ...
	'horizontalalignment', 'left', 'fontsize',12, ...
	'Backgroundcolor',[1.0 1.0 1.0], 'string', 'def.', 'visible', 'off');

text3 = uicontrol(ff,'Style','text', 'units','normalized', ...
	'Position',[.02 .19 .1 .04], ...
	'horizontalalignment', 'right', ...
	'fontsize',12, 'visible', 'off');
edit3 = uicontrol(ff,'Style','edit', 'units','normalized', ...
	'Position',[.12 .19 .1 .04], ...
	'horizontalalignment', 'left', 'fontsize',12, ...
	'Backgroundcolor',[1.0 1.0 1.0], 'string', 'def.', 'visible', 'off');

text4 = uicontrol(ff,'Style','text', 'units','normalized', ...
	'Position',[.02 .1 .1 .04], ...
	'horizontalalignment', 'right', ...
	'fontsize',12, 'visible', 'off');
edit4 = uicontrol(ff,'Style','edit', 'units','normalized', ...
	'Position',[.12 .1 .1 .04], ...
	'horizontalalignment', 'left', 'fontsize',12, ...
	'Backgroundcolor',[1.0 1.0 1.0], 'string', 'def.', 'visible', 'off');

	function help_plot(hp,boh)
		
		ind = get(lista,'value');
		mystr = {'erdrey','geo','gilbert','kleinberg','lockandkey','pref','renga','smallw','sticky'};
		mat = mystr{ind};
		set(help_text,'fontweight', 'normal', ...
			'fontsize', 10, 'String', help(mat));
		switch ind
			case 1
				set(text1, 'string','m ','visible', 'on');
				set(edit1, 'string', 'def.','visible', 'on');
				set(text2, 'visible', 'off');
				set(edit2, 'visible', 'off');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
				
			case 2
				set(text1, 'string', 'r ', 'visible', 'on');
				set(edit1, 'string', 'def.', 'visible', 'on');
				set(text2, 'string', 'm ', 'visible', 'on');
				set(edit2, 'string', 'def.', 'visible', 'on');
				set(text3, 'string', 'per ', 'visible', 'on');
				set(edit3, 'string', 'def.', 'visible', 'on');
				set(text4, 'string', 'pnorm ', 'visible', 'on');
				set(edit4, 'string', 'def.', 'visible', 'on');
				
			case 3
				set(text1, 'string', 'p ', 'visible', 'on');
				set(edit1, 'string', 'def.', 'visible', 'on');
				set(text2, 'visible', 'off');
				set(edit2, 'visible', 'off');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
			case 4
				set(text1, 'string', 'p ', 'visible', 'on');
				set(edit1, 'string', 'def.', 'visible', 'on');
				set(text2, 'string', 'q ', 'visible', 'on');
				set(edit2, 'string', 'def.', 'visible', 'on');
				set(text3, 'string', 'alpha ', 'visible', 'on');
				set(edit3, 'string', 'def.', 'visible', 'on');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
			case 5
				set(text1, 'string','m ','visible', 'on');
				set(edit1, 'string', 'def.','visible', 'on');
				set(text2, 'string', 'p ', 'visible', 'on');
				set(edit2, 'string', 'def.', 'visible', 'on');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
			case 6
				set(text1, 'string','d ','visible', 'on');
				set(edit1, 'string', 'def.','visible', 'on');
				set(text2, 'visible', 'off');
				set(edit2, 'visible', 'off');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
			case 7
				set(text1, 'string','lambda ','visible', 'on');
				set(edit1, 'string', 'def.','visible', 'on');
				set(text2, 'string', 'alpha ', 'visible', 'on');
				set(edit2, 'string', 'def.', 'visible', 'on');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
			case 8
				set(text1, 'string','k ','visible', 'on');
				set(edit1, 'string', 'def.','visible', 'on');
				set(text2, 'string', 'p ', 'visible', 'on');
				set(edit2, 'string', 'def.', 'visible', 'on');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
			case 9
				set(text1, 'string', 'gamma ', 'visible', 'on');
				set(edit1, 'string', 'def.', 'visible', 'on');
				set(text2, 'visible', 'off');
				set(edit2, 'visible', 'off');
				set(text3, 'visible', 'off');
				set(edit3, 'visible', 'off');
				set(text4, 'visible', 'off');
				set(edit4, 'visible', 'off');
		end
	end

	function OK_plot(hok,boh)
		ind = get(lista,'value');
		flag = 0;
		n = str2double(get(node_edit,'string'));
		if isnan(n), flag = 1; end
		while flag
			pos = [.3 .55 .4 .16];
			fww = figure('MenuBar', 'none', 'Name', 'n value is missing!', ...
				'NumberTitle', 'off',...
				'units','normalized',...
				'position', pos,'hittest', 'off', 'resize', 'on');
			strww = sprintf('I need a value for n!');
			uicontrol(fww,'style', 'text', ...
				'units', 'normalized', 'position', [.01 .5 .98 .4], ...
				'string', strww, ...
				'horizontalalignment', 'center', ...
				'fontsize',12, 'fontweight','bold','backgroundcolor', [.8 .8 .8]);
			hww = uicontrol(fww, 'units', 'normalized', ...
				'Position', [.3 .08 .4 .3], 'String', 'Continue', ...
				'Callback', 'uiresume(gcbf)');
			uiwait(gcf);
			if ishandle(fww)
				close(fww);
			end
			waitfor(node_edit,'string')
			n = str2double(get(node_edit,'string'));
			if ~isnan(n), flag = 0; end
		end
		switch ind
			case 1
				m = str2double(get(edit1,'string'));
				if isnan(m), m = ceil(n*log(n)/2); end
				A = erdrey(n,m);
			case 2
				r = str2double(get(edit1,'string'));
				if isnan(r), r = sqrt(1.44/n); end
				m = str2double(get(edit2,'string'));
				if isnan(m), m = 2; end
				per = str2double(get(edit3,'string'));
				if isnan(per), per = 0; end
				pnorm = str2double(get(edit4,'string'));
				if isnan(pnorm), pnorm = 2; end
				A = geo(n,r,m,per,pnorm);
			case 3
				p = str2double(get(edit1,'string'));
				if isnan(p), p = log(n)/n; end
				A = gilbert(n,p);
			case 4
				p = str2double(get(edit1,'string'));
				if isnan(p), p = 1; end
				q = str2double(get(edit2,'string'));
				if isnan(q), q = 1; end
				alpha = str2double(get(edit3,'string'));
				if isnan(alpha), alpha = 2; end
				A = kleinberg(n,p,q,alpha);
			case 5
				m = str2double(get(edit1,'string'));
				if isnan(m), m = ceil(n*log(n)); end
				p = str2double(get(edit2,'string'));
				if isnan(p), p = 1/n; end
				A = lockandkey(n,m,p);
			case 6
				d = str2double(get(edit1,'string'));
				if isnan(d), d = 2; end
				A = pref(n,d);
			case 7
				lambda = str2double(get(edit1,'string'));
				if isnan(lambda), lambda = 0.9; end
				alpha = str2double(get(edit2,'string'));
				if isnan(alpha), alpha = 1; end
				A = renga(n,lambda,alpha);
			case 8
				k = str2double(get(edit1,'string'));
				if isnan(k), k = 1; end
				p = str2double(get(edit2,'string'));
				if isnan(p), p = 0.1; end
				A = smallw(n,k,p);
			case 9
				gamma = str2double(get(edit1,'string'));
				if isnan(gamma), alpha = 2.5; end
				A = sticky(n,gamma);
		end
		
		
		uiresume(ff)
		
	end

	function annulla_plot(hObject,eventdata)
		uiresume(ff)
		close(ff)
	end

uiwait(ff)
if ishandle(ff), close(ff), end
end